
  <!DOCTYPE html>
  <html>
    <head>
      <title>index.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/model-configuring/index.tsx</td><td class="">95.32%</td><td class="">80%</td><td class="">1089</td><td class="">1038</td><td class="">51</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useMemo, useState } from &#x27;react&#x27;;
import { useHistory, useParams } from &#x27;react-router-dom&#x27;;
import s from &#x27;./model-configuring.module.scss&#x27;;
import { Header } from &#x27;../../components/Header/Header&#x27;;
import { Graphic, Heading, HeadingVariant } from &#x27;../../components&#x27;;
import { Button, ButtonVariant } from &#x27;../../components/Button/Button&#x27;;
import { ReactComponent as SaveAndContinueIcon } from &#x27;./assets/save-and-continue.svg&#x27;;
import { ReactComponent as SaveIcon } from &#x27;./assets/floppy-disk.svg&#x27;;
import { ReactComponent as CheckedIcon } from &#x27;./assets/checked.svg&#x27;;
import { ReactComponent as RemoveIcon } from &#x27;./assets/remove.svg&#x27;;
import { ReactComponent as RightIcon } from &#x27;./assets/right.svg&#x27;;
import { Table } from &#x27;../../components/Table/Table&#x27;;
import { Paths } from &#x27;../../routes/paths&#x27;;
import { TargetRole, targetRoles } from &#x27;../projects&#x27;;
import { Modal } from &#x27;../../components/Modal/Modal&#x27;;
import { ProjectBreadcrumbs } from &#x27;../project-settings&#x27;;
import { ItsMockedData } from &#x27;../../components/ItsMockedData/ItsMockedData&#x27;;
import {
  useFitProject,
  useInitialData,
  useProject,
  useUpdateProject
} from &#x27;../../queries/projects&#x27;;
import { format } from &#x27;date-fns&#x27;;
import {
  createErrorNotification,
  NOTY_TIMEOUT
} from &#x27;../../components/notifications&#x27;;
import {
  CustomizedTooltipField,
  CustomizedTooltipFieldValue
} from &#x27;../../components/Graphic/components/CustomizedTooltip&#x27;;
import { TableHeadingSelect } from &#x27;../../components/TableHeadingSelect/TableHeadingSelect&#x27;;
import { useIsCloneSelection } from &#x27;../../utils/useIsCloneSelection&#x27;;
import { FitParameter } from &#x27;../../api/projectSettings&#x27;;
import { useProjectSettings } from &#x27;../../queries/projectSettings&#x27;;
import {
  useCreateFeeds,
  useDeleteFeeds,
  useProjectFeeds
} from &#x27;../../queries/feeds&#x27;;
import { Feed } from &#x27;../../api/feed&#x27;;

const cloneSelectionRoles: { id: TargetRole; title: string }[] = [
  { id: &#x27;BatchID&#x27;, title: &#x27;Batch ID&#x27; },
  { id: &#x27;Time&#x27;, title: &#x27;Time&#x27; },
  { id: &#x27;Viable cell density&#x27;, title: &#x27;Viable Cell Density&#x27; },
  { id: &#x27;Cell viability&#x27;, title: &#x27;Viability&#x27; },
  { id: &#x27;Titer&#x27;, title: &#x27;Titer&#x27; }
];

const digitalTwinRoles: {
  id: TargetRole | FitParameter[&#x27;role&#x27;] | &#x27;Feed flow&#x27; | &#x27;Feed bolus&#x27;;
  title: string;
}[] = (
  cloneSelectionRoles as {
    id: TargetRole | FitParameter[&#x27;role&#x27;] | &#x27;Feed flow&#x27; | &#x27;Feed bolus&#x27;;
    title: string;
  }[]
).concat([
  { id: &#x27;Volume&#x27;, title: &#x27;Volume&#x27; },
  { id: &#x27;Independent&#x27;, title: &#x27;Input&#x27; },
  { id: &#x27;Metabolite&#x27;, title: &#x27;Metabolite&#x27; },
  { id: &#x27;Feed flow&#x27;, title: &#x27;Feed flow&#x27; },
  { id: &#x27;Feed bolus&#x27;, title: &#x27;Feed bolus&#x27; },
  { id: &#x27;Bleed rate&#x27;, title: &#x27;Bleed Flow&#x27; },
  { id: &#x27;Harvest&#x27;, title: &#x27;Harvest Flow&#x27; }
]);

const suboptions: { [key: string]: { id: string; title: string }[] } = {
  Metabolite: [
    {
      id: &#x27;Substrate factor&#x27;,
      title: &#x27;Substrate&#x27;
    },
    {
      id: &#x27;Quadratic factor&#x27;,
      title: &#x27;Quadratic&#x27;
    },
    {
      id: &#x27;Inhibitor factor&#x27;,
      title: &#x27;Inhibition&#x27;
    }
  ],
  Independent: [
    {
      id: &#x27;Substrate factor&#x27;,
      title: &#x27;Substrate&#x27;
    },
    {
      id: &#x27;Quadratic factor&#x27;,
      title: &#x27;Quadratic&#x27;
    },
    {
      id: &#x27;Inhibitor factor&#x27;,
      title: &#x27;Inhibition&#x27;
    }
  ]
};
export function getRandomColor() {
  var letters = &#x27;0123456789ABCDEF&#x27;;
  var color = &#x27;#&#x27;;
  for (var i = 0; i &lt; 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];
  }
  return color;
}
const Checkboxes = ({
  fields
}: {
  fields: { selected?: boolean; title: string }[];
}) =&gt; {
  return (
    &lt;div className={s.Checkboxes}&gt;
      {fields.map((field) =&gt; {
        return (
          &lt;div className={s.Checkboxes__item} key={field.title}&gt;
            {field.selected ? (
              &lt;CheckedIcon className={s.Checkboxes__checkedIcon} /&gt;
            ) : (
              &lt;RemoveIcon className={s.Checkboxes__removeIcon} /&gt;
            )}
            {field.title}
          &lt;/div&gt;
        );
      })}
    &lt;/div&gt;
  );
};

export const LastSaved = () =&gt; {
  const { projectId } = useParams&lt;{ projectId: string }&gt;();
  const project = useProject(projectId);
  if (!project.project || !project.project.date_modified) return null;
  return (
    &lt;div className={s.ModelConfiguring__saveDate}&gt;
      &lt;SaveIcon className={s.ModelConfiguring__saveDateIcon} /&gt;
      Last saved on{&#x27; &#x27;}
      {format(new Date(project.project.date_modified), &#x27;MMM dd, hh:mmaaa&#x27;)}
    &lt;/div&gt;
  );
};

export const ModelConfiguringPage = () =&gt; {
  const { projectId } = useParams&lt;{ projectId: string }&gt;();
  const project = useProject(projectId);
  const initialData = useInitialData(projectId);
  const projectSettings = useProjectSettings(projectId);
  const feeds = useProjectFeeds(projectId);
  const oldFitParameters = useMemo(
    () =&gt;
      projectSettings.data?.fitParameters.data.filter(
        (param) =&gt; param.role === &#x27;Independent&#x27; || param.role === &#x27;Metabolite&#x27;
      ) ?? [],
    [projectSettings.data?.fitParameters.data]
  );
  const selectedRolesFromFetchedProjectSettings = useMemo(() =&gt; {
    return oldFitParameters.reduce((acc, param) =&gt; {
      return {
        ...acc,
        [param.name]: param.role
      };
    }, {});
  }, [oldFitParameters]);
  const history = useHistory();
  const [selectedRoles, onChangeSelectedRoles] = useState&lt;{
    [key: string]: TargetRole;
  }&gt;({});
  const selectedSuboptionsFromFetchedProjectSettings = useMemo(() =&gt; {
    return oldFitParameters.reduce((acc, param) =&gt; {
      return {
        ...acc,
        [param.name]: param.type
      };
    }, {});
  }, [oldFitParameters]);

  const [selectedSuboption, onChangeSelectedSuboption] = useState&lt;{
    [key: string]: string;
  }&gt;({});
  const isCloneSelection = useIsCloneSelection();
  useEffect(() =&gt; {
    onChangeSelectedRoles((prev) =&gt; ({
      ...prev,
      ...selectedRolesFromFetchedProjectSettings
    }));
    onChangeSelectedSuboption((prev) =&gt; ({
      ...prev,
      ...selectedSuboptionsFromFetchedProjectSettings
    }));
  }, [
    selectedRolesFromFetchedProjectSettings,
    selectedSuboptionsFromFetchedProjectSettings
  ]);
  const selectedFitParameters: FitParameter[] = useMemo(() =&gt; {
    return Object.keys(selectedRoles)
      .map((selectedRoleKey) =&gt; ({
        key: selectedRoleKey,
        value: selectedRoles[selectedRoleKey]
      }))
      .filter(
        (role) =&gt;
          (role.value as any) === &#x27;Independent&#x27; ||
          (role.value as any) === &#x27;Metabolite&#x27;
      )
      .map(({ key, value }) =&gt; {
        return {
          role: value as any,
          type: selectedSuboption[key] as FitParameter[&#x27;type&#x27;],
          name: key,
          project: projectId,
          upper_bound: 0,
          lower_bound: 0,
          target: 0
        };
      });
  }, [projectId, selectedRoles, selectedSuboption]);
  console.log(&#x27;&gt;&gt; selectedRoles:&#x27;, selectedRoles);
  const selectedFeeds = useMemo(() =&gt; {
    const feeds = Object.keys(selectedRoles)
      .map((selectedRoleKey) =&gt; ({
        key: selectedRoleKey,
        value: selectedRoles[selectedRoleKey]
      }))
      .filter(
        ({ key, value }) =&gt;
          (value as any) === &#x27;Feed bolus&#x27; || (value as any) === &#x27;Feed flow&#x27;
      )
      .map((feed) =&gt; ({
        name: feed.key,
        type: feed.value,
        project_id: projectId,
        value: 0
      }));
    const metabolites = selectedFitParameters.filter(
      (param) =&gt; param.role === &#x27;Metabolite&#x27;
    );
    const resultFeeds: Feed[] = [];
    feeds.forEach((feed) =&gt; {
      metabolites.forEach((metabolite) =&gt; {
        resultFeeds.push({
          ...feed,
          metabolite_name: metabolite.name
        });
      });
    });
    return resultFeeds;
  }, [projectId, selectedRoles]);
  console.log(&#x27;&gt;&gt;&gt; selectedFeeds:&#x27;, selectedFeeds);
  useEffect(() =&gt; {
    if (project?.project?.columns_map) {
      onChangeSelectedRoles(
        Object.keys(project.project.columns_map as any).reduce((acc, key) =&gt; {
          const value = (project.project!.columns_map as any)[key];
          return { ...acc, [value]: key };
        }, {})
      );
    }
  }, [project.project]);
  const fieldToRole: { [key in TargetRole]: string } = useMemo(
    () =&gt;
      Object.keys(selectedRoles).reduce((acc, key) =&gt; {
        const kk: any = selectedRoles[key];
        if (
          kk === &#x27;Metabolite&#x27; ||
          kk === &#x27;Independent&#x27; ||
          kk === &#x27;Feed flow&#x27; ||
          kk === &#x27;Feed bolus&#x27;
        )
          return acc;
        if (kk) {
          return {
            ...acc,
            [kk]: key
          };
        }
        return acc;
      }, {}) as { [key in TargetRole]: string },
    [selectedRoles]
  );

  const ColumnTitleRenderer = useCallback(
    ({ title, name }: { name: string; title: React.ReactNode }) =&gt; {
      const props = { columnName: title } as any;
      const opts = suboptions[selectedRoles[name]]?.map((role) =&gt; ({
        value: role.id,
        label: role.title
      }));
      return (
        &lt;div className={s.ModelConfiguring__tableTitle} {...props}&gt;
          &lt;div {...props}&gt;{title}&lt;/div&gt;
          &lt;TableHeadingSelect
            name=&quot;Role&quot;
            value={selectedRoles[name]}
            onChange={(value) =&gt; {
              onChangeSelectedRoles((prev) =&gt; {
                if (selectedRoles[name] === value) {
                  const newSelectedRoles = {
                    ...prev
                  };
                  delete newSelectedRoles[name];
                  return newSelectedRoles;
                }
                const newSelectedRoles = {
                  ...prev,
                  [name]: value as TargetRole
                };
                Object.keys(newSelectedRoles).forEach((key) =&gt; {
                  if (
                    newSelectedRoles[key] === value &amp;&amp;
                    key !== name &amp;&amp;
                    targetRoles.includes(newSelectedRoles[key] as TargetRole)
                  ) {
                    delete newSelectedRoles[key];
                  }
                });
                return newSelectedRoles;
              });
            }}
            options={(isCloneSelection
              ? cloneSelectionRoles
              : digitalTwinRoles
            ).map((role) =&gt; ({
              value: role.id,
              label: role.title
            }))}
          /&gt;
          {opts &amp;&amp; opts.length &gt; 0 &amp;&amp; (
            &lt;TableHeadingSelect
              value={selectedSuboption[name]}
              onChange={(value) =&gt; {
                onChangeSelectedSuboption((prev) =&gt; {
                  if (selectedSuboption[name] === value) {
                    const newSelectedRoles = {
                      ...prev
                    };
                    delete newSelectedRoles[name];
                    return newSelectedRoles;
                  }
                  const newSelectedRoles = {
                    ...prev,
                    [name]: value
                  };

                  return newSelectedRoles;
                });
              }}
              name=&quot;Type&quot;
              options={opts}
            /&gt;
          )}
        &lt;/div&gt;
      );
    },
    [isCloneSelection, selectedRoles, selectedSuboption]
  );

  const rows = useMemo(() =&gt; initialData.data || [], [initialData.data]);

  const columns = useMemo(() =&gt; {
    return Object.keys(rows.reduce((acc, row) =&gt; ({ ...acc, ...row }), {})).map(
      (c) =&gt; ({
        title: ColumnTitleRenderer({ title: c, name: c }),
        name: c
      })
    );
  }, [ColumnTitleRenderer, rows]);

  const [tableWrapperRef, setTableWrapperRef] = useState&lt;HTMLDivElement | null&gt;(
    null
  );
  const [canTableScroll, setCanTableScroll] = useState(false);
  const scrollToRight = useCallback(() =&gt; {
    if (tableWrapperRef) {
      tableWrapperRef.scrollLeft += 80;
    }
  }, [tableWrapperRef]);

  const [scrollTop, setScrollTop] = useState(0);
  useEffect(() =&gt; {
    if (tableWrapperRef) {
      const handler = () =&gt; {
        setScrollTop(tableWrapperRef.scrollTop);
      };
      tableWrapperRef.addEventListener(&#x27;scroll&#x27;, handler);

      if (tableWrapperRef.clientWidth &lt; tableWrapperRef.scrollWidth) {
        setCanTableScroll(true);
      }
      return () =&gt; tableWrapperRef.removeEventListener(&#x27;scroll&#x27;, handler);
    }
  }, [tableWrapperRef]);
  const [selectedKey, setSelectedKey] = useState&lt;null | string&gt;(null);
  const handleTableClick = useCallback((e) =&gt; {
    const columnName = e.target.getAttribute(&#x27;columnname&#x27;) || null;
    if (columnName) {
      setSelectedKey(columnName);
    }
  }, []);
  const batchNames = useMemo(() =&gt; {
    if (!fieldToRole[&#x27;BatchID&#x27;]) {
      return [];
    }
    const batchColumn = fieldToRole[&#x27;BatchID&#x27;];
    const set = rows.reduce(
      (acc, row) =&gt; ({
        ...acc,
        [(row as any)[batchColumn]]: true
      }),
      {}
    );
    return Object.keys(set);
  }, [rows, fieldToRole]);

  const preparedData = useMemo(() =&gt; {
    if (!selectedKey)
      return {
        isBatched: false,
        isTimed: false,
        data: []
      };
    const batchIdColumnName = fieldToRole[&#x27;BatchID&#x27;];
    const timeColumnName = fieldToRole[&#x27;Time&#x27;];
    let data = [];

    if (!timeColumnName) {
      if (!batchIdColumnName) {
        data = rows.map((row, idx) =&gt; ({
          name: selectedKey,
          id: idx,
          x: idx,
          y: ((row as any)[selectedKey] as number) || null
        }));
      } else {
        data = rows.map((row, idx) =&gt; ({
          name: selectedKey,
          id: idx,
          x: idx,
          [(row as any)[batchIdColumnName as string]]:
            ((row as any)[selectedKey] as number) || null
        }));
      }
    } else if (timeColumnName &amp;&amp; !batchIdColumnName) {
      data = rows.map((row, idx) =&gt; ({
        name: selectedKey,
        id: (row as any)[timeColumnName] as number,
        x: (row as any)[timeColumnName] as number,
        y: ((row as any)[selectedKey] as number) || null
      }));
    } else {
      data = rows.map((row, idx) =&gt; ({
        name: selectedKey,
        id: (row as any)[timeColumnName] as number,
        x: (row as any)[timeColumnName] as number,
        [(row as any)[batchIdColumnName as string]]:
          ((row as any)[selectedKey] as number) || null
      }));
    }
    return {
      data: data.sort((a, b) =&gt; a.x - b.x),
      isBatched: Boolean(batchIdColumnName),
      isTimed: Boolean(timeColumnName)
    };
  }, [rows, selectedKey, fieldToRole]);

  const filledMaps = useMemo(() =&gt; {
    return {
      batchId: Boolean(fieldToRole[&#x27;BatchID&#x27;]),
      time: Boolean(fieldToRole[&#x27;Time&#x27;]),
      viableCellDensity: Boolean(fieldToRole[&#x27;Viable cell density&#x27;]),
      viability: Boolean(fieldToRole[&#x27;Cell viability&#x27;]),
      titer: Boolean(fieldToRole[&#x27;Titer&#x27;])
    };
  }, [fieldToRole]);
  const [isBuildModalOpen, changeBuildModalOpen] = useState(false);
  const { mutateAsync: mutateAsyncUpdateProject } = useUpdateProject();
  const { mutateAsync: mutateAsyncCreateFeeds } = useCreateFeeds();
  const { mutateAsync: mutateAsyncDeleteFeeds } = useDeleteFeeds();
  const { mutateAsync: mutateAsyncFitProject } = useFitProject({
    projectId: projectId
  });

  const viabilityData = useMemo(() =&gt; {
    const viabilityKey = fieldToRole[&#x27;Cell viability&#x27;];
    if (!viabilityKey || !initialData.data) return [];
    return initialData.data.map((row) =&gt; (row as any)[viabilityKey]);
  }, [initialData.data, fieldToRole]);

  const isEveryValueOfViabilityDataPercent = useMemo(() =&gt; {
    return viabilityData.every((viabilityDataItem) =&gt; {
      if (typeof viabilityDataItem !== &#x27;number&#x27;) return true;
      return viabilityDataItem &gt;= 0 &amp;&amp; viabilityDataItem &lt;= 1;
    });
  }, [viabilityData]);
  useEffect(() =&gt; {
    const bla = feeds.data?.data.reduce((acc, feed) =&gt; {
      return {
        ...acc,
        [feed.name]: feed.type
      };
    }, {});
    console.log(&#x27;bla&#x27;, bla);
    if (bla) {
      onChangeSelectedRoles((prev) =&gt; ({ ...prev, ...bla }));
    }
  }, [feeds.data?.data]);
  console.log(&#x27;&gt;&gt;&gt; selectedRoles:&#x27;, selectedRoles);
  const isNeedVolume = useMemo(() =&gt; {
    // fieldToRole.
  }, []);
  console.log(&#x27;&gt;&gt; feeds:&#x27;, feeds);
  return (
    &lt;div className={s.ProjectSettings}&gt;
      {isBuildModalOpen &amp;&amp; (
        &lt;Modal
          onClose={() =&gt; {
            changeBuildModalOpen(false);
          }}
          className={s.ModelConfiguring__modal}
          title=&quot;Create model&quot;
        &gt;
          &lt;div className={s.ModelConfiguring__modalContent}&gt;
            &lt;div className={s.ModelConfiguring__modalHeading}&gt;
              The model creation process may take up to several hours, depending
              on the complexity of your data.
            &lt;/div&gt;

            &lt;div className={s.ModelConfiguring__actionText}&gt;
              Are you sure that you want to create your model now?
            &lt;/div&gt;
            &lt;div className={s.ModelConfiguring__buttons}&gt;
              &lt;Button
                hoverVariant={ButtonVariant.ACTION}
                onClick={() =&gt; {
                  mutateAsyncFitProject().then(() =&gt;
                    changeBuildModalOpen(false)
                  );
                }}
              &gt;
                Create model
              &lt;/Button&gt;
              &lt;Button
                hoverVariant={ButtonVariant.ACTION}
                onClick={() =&gt; {
                  changeBuildModalOpen(false);
                }}
              &gt;
                Cancel
              &lt;/Button&gt;
            &lt;/div&gt;
          &lt;/div&gt;
        &lt;/Modal&gt;
      )}
      &lt;Header /&gt;
      &lt;ProjectBreadcrumbs /&gt;
      {project?.project?.isInRenderQueue &amp;&amp; (
        &lt;ItsMockedData&gt;We are waiting for the model to learn&lt;/ItsMockedData&gt;
      )}
      &lt;div className={s.ProjectSettings__content}&gt;
        &lt;div className={s.ModelConfiguring__contentLeft}&gt;
          &lt;Heading
            className={s.ProjectSettings__headingH2}
            variant={HeadingVariant.H2}
          &gt;
            Model Configuration
          &lt;/Heading&gt;
          &lt;LastSaved /&gt;
        &lt;/div&gt;
        &lt;Button
          hoverVariant={ButtonVariant.ACTION}
          rightIcon={&lt;SaveAndContinueIcon /&gt;}
          uppercase
          disabled={
            !filledMaps.viability ||
            !filledMaps.viableCellDensity ||
            !filledMaps.time ||
            !filledMaps.batchId ||
            project?.project?.isInRenderQueue
          }
          size=&quot;small&quot;
          onClick={() =&gt; {
            if (!isEveryValueOfViabilityDataPercent) {
              createErrorNotification({
                text: &#x27;Viability column should contain only percent values&#x27;,
                timeout: NOTY_TIMEOUT
              }).show();
              return;
            }

            mutateAsyncDeleteFeeds({
              projectId,
              feedIds: feeds.data?.data?.map((feed) =&gt; feed.id) || []
            }).then(() =&gt;
              mutateAsyncCreateFeeds({
                projectId,
                feeds: selectedFeeds
              }).then(() =&gt;
                mutateAsyncUpdateProject({
                  columnsMap: fieldToRole,
                  newFitParameters: selectedFitParameters,
                  deleteFitParameters: oldFitParameters.map((f) =&gt; f.id),
                  projectId: projectId as string
                }).then((data) =&gt; {
                  if (
                    data.data?.creating_step === &#x27;Data upload&#x27; &amp;&amp;
                    (!project?.project || !project.project.isInRenderQueue)
                  ) {
                    changeBuildModalOpen(true);
                  } else {
                    history.push(
                      Paths.CLONE_SELECTION_FITTING.replace(
                        /:projectId/gi,
                        projectId
                      )
                    );
                  }
                })
              )
            );
          }}
        &gt;
          Save &amp; Continue
        &lt;/Button&gt;
      &lt;/div&gt;
      &lt;div className={s.ModelConfiguring__frames}&gt;
        &lt;div className={s.ModelConfiguring__tableFrame}&gt;
          &lt;div className={s.ModelConfiguring__tableFrameHead}&gt;
            &lt;div className={s.ModelConfiguring__frameTitle}&gt;
              Bioreactor Data
            &lt;/div&gt;
            &lt;Checkboxes
              fields={[
                {
                  selected: filledMaps.batchId,
                  title: &#x27;Batch ID&#x27;
                },
                {
                  selected: filledMaps.time,
                  title: &#x27;Time&#x27;
                },
                {
                  selected: filledMaps.viableCellDensity,
                  title: &#x27;Viable Cell Density&#x27;
                },
                {
                  selected: filledMaps.viability,
                  title: &#x27;Viability&#x27;
                }
              ]}
            /&gt;
          &lt;/div&gt;
          {canTableScroll &amp;&amp; (
            &lt;div
              className={s.ModelConfiguring__tableScrollIcon}
              onClick={scrollToRight}
            &gt;
              &lt;RightIcon /&gt;
            &lt;/div&gt;
          )}
          &lt;div ref={setTableWrapperRef} className={s.ModelConfiguring__table}&gt;
            &lt;Table
              onClick={handleTableClick}
              scrollTop={scrollTop}
              rows={rows as any[]}
              columns={columns}
            /&gt;
          &lt;/div&gt;
        &lt;/div&gt;
        &lt;div&gt;
          &lt;div className={s.ModelConfiguring__frameTitle}&gt;
            Batch Trajectories
          &lt;/div&gt;
          &lt;div
            style={{
              height: &#x27;calc(100vh - 300px + 35px)&#x27;,
              width: &#x27;100%&#x27;
            }}
          &gt;
            &lt;Graphic
              data={preparedData.data}
              xAxis={{
                dataKey: &#x27;x&#x27;,
                label: preparedData.isTimed ? &#x27;Time&#x27; : &#x27;Index&#x27;
              }}
              yAxisUnit={selectedKey || &#x27;&#x27;}
              lines={
                preparedData.isBatched
                  ? batchNames.map((batchName) =&gt; ({
                      dataKey: batchName,
                      name: batchName
                    }))
                  : [
                      {
                        dataKey: &#x27;y&#x27;,
                        name: &#x27;&#x27;
                      }
                    ]
              }
              renderTooltip={(payload) =&gt; (
                &lt;div&gt;
                  &lt;CustomizedTooltipField&gt;
                    {payload.dataKey}:{&#x27; &#x27;}
                    &lt;CustomizedTooltipFieldValue&gt;
                      {payload.x}
                    &lt;/CustomizedTooltipFieldValue&gt;
                  &lt;/CustomizedTooltipField&gt;
                  &lt;CustomizedTooltipField&gt;
                    {preparedData.isTimed ? &#x27;Time&#x27; : &#x27;Index&#x27;}:{&#x27; &#x27;}
                    &lt;CustomizedTooltipFieldValue&gt;
                      {payload.y}
                    &lt;/CustomizedTooltipFieldValue&gt;
                  &lt;/CustomizedTooltipField&gt;
                &lt;/div&gt;
              )}
            /&gt;
          &lt;/div&gt;
        &lt;/div&gt;
      &lt;/div&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:202,&quot;character&quot;:11,&quot;text&quot;:&quot;role.value as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:203,&quot;character&quot;:11,&quot;text&quot;:&quot;role.value as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:207,&quot;character&quot;:10,&quot;text&quot;:&quot;role&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:207,&quot;character&quot;:16,&quot;text&quot;:&quot;value as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:208,&quot;character&quot;:16,&quot;text&quot;:&quot;selectedSuboption[key] as FitParameter[&#x27;type&#x27;]&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:226,&quot;character&quot;:11,&quot;text&quot;:&quot;value as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:226,&quot;character&quot;:46,&quot;text&quot;:&quot;value as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:252,&quot;character&quot;:20,&quot;text&quot;:&quot;project.project.columns_map as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:253,&quot;character&quot;:16,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:253,&quot;character&quot;:25,&quot;text&quot;:&quot;project.project!.columns_map as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:253,&quot;character&quot;:25,&quot;text&quot;:&quot;project.project!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:254,&quot;character&quot;:28,&quot;text&quot;:&quot;value&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:261,&quot;character&quot;:6,&quot;text&quot;:&quot;Object.keys(selectedRoles).reduce((acc, key) =&gt; {\n        const kk: any = selectedRoles[key];\n        if (\n          kk === &#x27;Metabolite&#x27; ||\n          kk === &#x27;Independent&#x27; ||\n          kk === &#x27;Feed flow&#x27; ||\n          kk === &#x27;Feed bolus&#x27;\n        )\n          return acc;\n        if (kk) {\n          return {\n            ...acc,\n            [kk]: key\n          };\n        }\n        return acc;\n      }, {}) as { [key in TargetRole]: string }&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:262,&quot;character&quot;:14,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:264,&quot;character&quot;:10,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:265,&quot;character&quot;:10,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:266,&quot;character&quot;:10,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:267,&quot;character&quot;:10,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:270,&quot;character&quot;:12,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:273,&quot;character&quot;:13,&quot;text&quot;:&quot;kk&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:283,&quot;character&quot;:12,&quot;text&quot;:&quot;props&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:283,&quot;character&quot;:20,&quot;text&quot;:&quot;{ columnName: title } as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:305,&quot;character&quot;:26,&quot;text&quot;:&quot;value as TargetRole&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:393,&quot;character&quot;:40,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:394,&quot;character&quot;:10,&quot;text&quot;:&quot;columnName&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:394,&quot;character&quot;:23,&quot;text&quot;:&quot;e&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:394,&quot;character&quot;:25,&quot;text&quot;:&quot;target&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:394,&quot;character&quot;:32,&quot;text&quot;:&quot;getAttribute&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:395,&quot;character&quot;:8,&quot;text&quot;:&quot;columnName&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:407,&quot;character&quot;:10,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:423,&quot;character&quot;:8,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:427,&quot;character&quot;:8,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:431,&quot;character&quot;:15,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:434,&quot;character&quot;:8,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:438,&quot;character&quot;:12,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:439,&quot;character&quot;:14,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:443,&quot;character&quot;:6,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:445,&quot;character&quot;:13,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:446,&quot;character&quot;:12,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:447,&quot;character&quot;:13,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:450,&quot;character&quot;:6,&quot;text&quot;:&quot;data&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:452,&quot;character&quot;:13,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:453,&quot;character&quot;:12,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:454,&quot;character&quot;:10,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:455,&quot;character&quot;:12,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:482,&quot;character&quot;:8,&quot;text&quot;:&quot;viabilityData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:485,&quot;character&quot;:42,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:489,&quot;character&quot;:11,&quot;text&quot;:&quot;viabilityData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:489,&quot;character&quot;:32,&quot;text&quot;:&quot;viabilityDataItem&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:490,&quot;character&quot;:17,&quot;text&quot;:&quot;viabilityDataItem&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/model-configuring/index.tsx&quot;,&quot;line&quot;:493,&quot;character&quot;:6,&quot;text&quot;:&quot;viabilityData&quot;,&quot;kind&quot;:2}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  